www-Sharp

www-Sharp is a professional HTML editor for designing, coding, and developing websites, html pages, web and HTML applications. www-Sharp contains tools for hand-coding HTML/PHP/ASP/ASP.Net pages as well as powerfull HTML designer.

www-Sharp allows quickly create html pages and use newest technologies such as HTML+TIME 2.0.

www-Sharp includes www-Sharp.Runtime - in-process web-server that greatly enhances HTML application model introduced in Internet Explorer 5. www-Sharp.Runtime allows run PHP/ASP/ASP.Net/ISAPI applications without need for standalone web-server.

Many tools included with www-Sharp will make creation of web applications easy.


www-Sharp: HTML application

HTML Applications

The power to build HTML Applications (HTAs) brings Microsoft® Internet Explorer 5 to the fore as a viable Microsoft Windows® development platform. HTAs are full-fledged applications. These applications are trusted and display only the menus, icons, toolbars, and title information that the Web developer creates. In short, HTAs pack all the power of Internet Explorer—its object model, performance, rendering power, protocol support, and channel-download technology—without enforcing the strict security model and user interface of the browser.

Why Use HTAs

Historically, programming languages like C++ and Microsoft Visual Basic® have provided the object models and access to system resources that developers demand. With HTA it is now time to add Dynamic HTML (DHTML) with script to that list. HTAs not only support everything a Web page does—namely HTML, Cascading Style Sheets (CSS), scripting languages, and behaviors—but also HTA-specific functionality. This added functionality provides control over user interface design and access to the client system. Moreover, run as trusted applications, HTAs are not subject to the same security constraints as Web pages. As with any executable file, the user is asked once, before the HTA is downloaded, whether to save or run the application; if saved to the client machine, it simply runs on demand thereafter. The end result is that HTAs runs like any executable (.exe) written in C++ or Visual Basic.

HTAs are suited to many uses, whether you are prototyping, making wizards, or building full-scale applications. Whatever DHTML and script deliver now—forms, multimedia, Web applications, HTML editors, and browsers—so can HTAs...and then some. Best of all, HTAs make some tasks easier. The simplicity of generating prototypes using HTAs makes it possible for program managers and designers to script dialog boxes and alerts while the C++ or Visual Basic developers program the underlying functionality.

Creating simple HTA

Choose "File\New\Syntax editor" in application menu. Write one line:

Hello, world!

and save file into harddrive with .hta extension (for example, hello.hta). Start this file from Windows Explorer.

For examining HTA properties look at "HTA Properties" example (located in Examples folder in directory where www-Sharp is installed).

Compiling HTML application

www-Sharp lets you compile HTML application into the single file. Unlike www-Sharp.Runtime this solution does not allow server-side scripts. Startup page for compiled HTA is index.hta file in application root directory - this file must present in project.

In application menu choose "File\Compile HTA ...". In file field enter file name into which you want to compile HTA (file should have ".wsits" extension). In directory field enter root directory of your HTA. Check files that you want to compile and press "Compile " button.

Deploying compiled HTML application

Compiled HTA (as well as normal HTA) requires Internet Explorer 5 installed on client computer. You need to deploy compiled file (with ".wsits" extension) and register extension handler (all files needed to handle wsits files are installed yet with IE5+). To register handler for .wsits files you should add some values into registry.

Register for all users on computer (requires administrator privileges on Windows NT 4.0, 2000, XP, 2003):

REGEDIT4

[HKEY_LOCAL_MACHINE\SOFTWARE\Classes\.wsits]
@="WSITS file"

[HKEY_LOCAL_MACHINE\SOFTWARE\Classes\WSITS file]
@="Compiled HTML application"

[HKEY_LOCAL_MACHINE\SOFTWARE\Classes\WSITS file\DefaultIcon]
@="itss.dll,0"

[HKEY_LOCAL_MACHINE\SOFTWARE\Classes\WSITS file\shell\open\command]
@="mshta.exe ms-its:%1::/index.hta"

Register for current user (not supported on Windows 98, Me, NT 4.0):

REGEDIT4

[HKEY_CURRENT_USER\SOFTWARE\Classes\.wsits]
@="WSITS file"

[HKEY_CURRENT_USER\SOFTWARE\Classes\WSITS file]
@="Compiled HTML application"

[HKEY_CURRENT_USER\SOFTWARE\Classes\WSITS file\DefaultIcon]
@="itss.dll,0"

[HKEY_CURRENT_USER\SOFTWARE\Classes\WSITS file\shell\open\command]
@="mshta.exe ms-its:%1::/index.hta"

Copy this code into file with .reg extension and run it on user computer. You may also add these registry settings with your installation program - look its documentation for information on how to do this.

ATTN: you should not customize handler settings for wsits files - user computer may have other wsits files that will not work after such customization. If you need this, register your own extension.

Additional note:

Compiling HTML application is archiving it into format similar to one used by compiled HTML help (.chm) files. This means that those files could be decompiled quite easy.


www-Sharp: Snippets

Snippets

Snippets in www-Sharp are very powerfull and easy to use. They not only support raw text but also let you run simple (and not so simple) scripts.

Scripts run on html page that is displayed to user the way similar to window.showModalDialog(). When dialog closes it should return generated string in window.returnValue. The first "|" char shows position of cursor after inserting snippet text (cursor position is set only in www-Sharp syntax editor, on other targets this char will be removed).

When you had wrote snippet page, you should add snippet with type "Command" (right-click on custom snippets tree and choose appropriate item in menu). Caption is text shown in tree, description is shown as hint. Command itself has two parts separated by "|" char. First part is URL (you can register URL with www-Sharp.Runtime or add your page into Snippets folder under directory where www-Sharp is installed, its URL is www-sharp://www-Sharp.Snippets/). Second part is parameters - it is the same parameters as those used by window.showModalDialog().

Of course, you may drag-and-drop snippets onto the new location.


www-Sharp: Wizards and Reports

Wizards/Reports

Wizards and Reports in www-Sharp are analogs of plugins in many other programs. However in www-Sharp it is very easy to create new wizard and reports.

Wizards run in modal HTML dialog. It is an HTML page that contains some script. Wizard's window.dialogArguments property is wwwSharp.Application object, so you can get current project path, URL. Look $(wwwSharp)\Wizards\siteSummary.html (where $(wwwSharp) is directory where www-Sharp is installed) for example.

Reports run in browser window. wwwSharp.Application object is available as window.external object. Unlike wizard report runs as untrusted html page, Internet explorer can cofirm do you want to execute script.

You can add/remove wizards and reports in Wizards settings page (select View\Property in menu).


www-Sharp designers

Creating designer for HTML element

www-Sharp HTML editor lets you create own designers for every HTML element. This tutorial shows how to create designer for header (H1 - H6) elements.

www-Sharp designer is HTML page that is shown similar way as window.showModelessDialog() when user double-click on HTML element holding ALT button. window.dialogArguments is designing HTML element. Common variables that you can use while manipulating this element are:

  • element = window.dialogArguments;
  • elementDocument = element.document;
  • elementWindow = elementDocument.parentWindow;

Be sure to use elementDocument when working with designing element. Trying insert child element, created with document.createElement(), to designing element can have inpredictable results.

Example "HeaderDesigner" (can be found in Examples folder under directory where www-Sharp is installed) shows source for HeaderDesigner. As you can see, in body.onload handler designer controls are initialized. Then user can change them. And when user press OK or Apply button, changes are passed to designing element.

When designer page is ready you should register designer in www-Sharp. To do this, choose "View\Properties" in application menu and select "User interface\HTML Editor" settings. Choose "Designers" tab. Press "Add designer" button and enter "H1" into Tag column. Choose handler column and press "..." button. In dialog enter "www-sharp://www-Sharp.Examples/HeaderDesigner/header.html" into URL (www-Sharp registers "www-sharp://www-Sharp.Examples/" domain for Exmaples folder) and "dialogHeight=250pt;dialogWidth=350pt;resizable:yes;help:no" into Options (options are the same as for window.showModelessDialog()). You can optionally specify class name for which this handler is, empty class name means default handler for elements with specified tag name. Repeat this operation for H2, H3, H4. H5 and H6 tags.

Now when you double-click on header holding ALT in www-Sharp HTML designer (designer mode) you will see this designer.

P.S. Double-clicking on element holding SHIFT, CTRL or SHIFT+CTRL are also functional.


www-Sharp syntax editor

www-Sharp includes powerfull text editor with syntax highlighting. For list of supported formats look View\Highlighter in program menu.

www-Sharp syntax editor supports bookmarks, print with print preview, displaying non-printable symbols and many other features.

Text that is inside syntax editor can be compared with contents of other file (choose View\Compare with in program menu), converted in another codepage (choose View\Convert code page in program menu).

To customize www-Sharp syntax editor choose View\Settings in program menu and go to User interface\Syntax editor entry. Highlighters can be customized with User interface\Highlighters settings.

Syntax editor supports some drop-down menus:

  • CTRL+SHIFT+H - HTML elements;
  • CTRL+SHIFT+C - CSS elements;
  • CTRL+SHIFT+X - XSL elements;
  • CTRL+SHIFT+T - COM type libraries;
  • CTRL+SHIFT+N - .Net assemblies.

www-Sharp drop-down menus are multi-level. You can go to next level by pressing CTRL+ENTER, return to previous level by pressing BACKSPACE.


www-Sharp HTML editor

www-Sharp HTML editor is one of the most advanced HTML editors. It provides tools for manual editing HTML files as well as advanced visual HTML designer.

www-Sharp HTML editor has 4 views:

  • Editor - used for manual editing HTML files.
  • Preview - used for preview HTML file. Preview shows HTML page in web browser, it does not change source of html page.
  • Designer - used for visual designing HTML files. Unlike Preview it does not execute scripts and changes source of html page. Designer uses MSHTML engine that is fully compatible with Internet Explorer.

    www-Sharp HTML designer has unique tools that greatly simplifies design process. This tools can be accessed by double-clicking HTML element with:

    • SHIFT+DBLCLICK: edit element's outerHTML.
    • CTRL+DBLCLICK: edit element's DOM - similar to DOM view but with selected element as root.
    • ALT+DBLCLICK: edit element with custom designer. Custom designers can be set by selecting View\Properties in application menu and selecting User interface\HTML editor entry, Designers tab. You can preset custom designer for elements with specific HTML tag and even specific className (empty className means default designer for this tag) . Custom designer is HTML page that is shown as with window.showModelessDialog. Element object is assigned to window.dialogArguments. You can manipulate element's properties with script. Note that if you create new elements with document.createElement() and insert them into designing HTML document, you should use document object that corresponds to designing element. Main objects that you can use in your own custom designer are:
      • element = window.dialogArguments;
      • elementDocument = element.document;
      • elementWindow = elementDocument.parentWindow;
    • SHIFT+CTRL+DBLCLICK: edit element with ScriptConsole. You can access designing element with Element object in ActiveX scripts (JScript, VBScript etc.) and JScript.Net (requires .Net Framework). For example, select JScript and execute "Host.WriteLn(Element.tagName);" (without quotes). You can get element's document and window as well as in custom editor.

    www-Sharp HTML designer supports formatting HTML code with PrettyHTML (PrettyHTML button on toolbar). This lets have good formatted html pages in uniform style. Formatting happens when you switch from designer/DOM view to editor view. You can turn off PrettyHTML to get html page as it is returned by MSHTML.

  • DOM - used for working with DOM structure of HTML document. HTML DOM structure

    DOM viewer has 3 main parts - DOM tree, object inspector and outerHTML editor. You can update object property by changing its value in object inspector. You can update element's outerHTML by pressing CTRL+ENTER in outerHTML editor.


www-Sharp XML editor

www-Sharp XML editor is one of the most powerfull tools for editing XML, XSL, XSD files. It consists of Editor and Designer part.

Editor is used to manually edit XML file.

Designer provides visual interface that lets you edit and format XML files.

Designer has 4 main parts - XML tree, Attributes panel, Node XML panel and XPath combobox.

XML tree represents document as tree. You can click on any node to display its attributes in attributes panel and XML in Node XML panel. XML tree lets you drag-and-drop node to change its location.

Attributes panel shows node's attributes. Attributes can have child nodes - text and entity reference nodes. Value column is editable.

Node XML panel shows node XML . You can edit node XML and update it by pressing CTRL+ENTER keys.

Toolbar has buttons to insert/delete nodes, validate XML document, transform node XML with XSL template and setup XML transformation parameters (PrettyXML).

XPath combobox contains XPath query that is applied to document. Empty query means whole XML document.


www-Sharp RTF editor

www-Sharp RTF editor is enhanced WordPad. It supports more features such as text justification, subscript/superscript text, line spacing, zoom and others.


www-Sharp .Net project

www-Sharp contains IDE for creating .Net assemblies. This feature requires Microsoft .Net Framework 1.1 to be installed. www-Sharp .Net project works with C#, VB.Net and JScript.Net projects.

To create .Net project select File\New\.Net project in application menu.

New .Net project

Choose project template (project templates are stored in $(wwwSharp)\Projects directory, where $(wwwSharp) is directory where www-Sharp is installed) .

Choose project file.

Set referenced assemblies in References tab:

New .Net project references

Check all assemblies that you want to reference from your .Net project.

Edit configurations. Note that target field is important and should be correspond to "Generate executable" checkbox in Command tab.

New .Net project options

Press OK.

Now you have initial .Net project. You can add/delete files, references, resources, edit source code etc. When your project is ready, press Build button to compile it. If your project is executable you can start debugging it with CLR debugger (requires .Net Framework SDK, you may need to setup its location in View\Properties\Tools in application menu).

www-Sharp .Net project contains some tools that will simplify common tasks - create new strong name key, convert .Net assemly into COM type library and vice-versa, install .Net assembly into GAC and remove it from there.


www-Sharp help project

www-Sharp contains tool for creating HTML help files (.chm). This tool require Microsoft Help Workshop to be installed. If location of Html Help Compiler (hhc.exe) is not determined automatically, you should also set its location - in application menu choose View\Properties, goto Tools item and enter location of HTML Help compiler - hhc.exe. It should be on the same directory where Html Help Workshop is installed.

www-Sharp help editor is similar to Microsoft Help Workshop but is much more comfortable.


www-Sharp browser

www-Sharp browser lets you navigate to any URL. If project is open, you can navigate to it with URL that you specified in Open project dialog or with www-sharp://www-Sharp.Project/ URL if no URL was provided.


www-Sharp COM type libraries viewer

www-Sharp COM type libraries viewer shows lets you explore type libraries that are installed on your computer. It is very usefull if you are using COM objects in your applications/web pages and want to know its properties/methods.

COM type libraries viewer


www-Sharp .Net assemblies viewer

www-Sharp .Net assemblies viewer lets you examine .Net assemblies that are installed on your computer.

.Net assemblies viewer


www-Sharp script console

www-Sharp script console lets you execute scripts and immediately see its output. It is very usefull for debugging purposes and just to see what specific function does.

www-Sharp script console supports ActiveX script engines such as JScript, VBScript, PerlScript, Python (only JScript and VBScript are installed with Internet Explorer, other engines should be installed separately), JScript.Net (requires .Net Framework 1.1), batch files, PHP scripts (through php_cli.exe) and .Net programs (one-unit program that compiles on the fly and sends its output into output window). You can execute script by pressing button on toolbar or by pressing CTRL+ENTER.

Script engines used by www-Sharp s cript console could be separated on two groups :

  • In-process script engines: run inside www-Sharp process and use Host object to send output into output window. This group includes all ActiveX script engines (JScript, VBScript etc.) and JScript.Net (www-Sharp uses VSA to run JScript.Net script) . This group can use script objects.
  • Out-of-process engines: www-Sharp starts new process and collects its output. This group includes batch files, PHP and .Net programs. This group has no access to script objects.

Script objects:

"Host" object is used to collect output from script.

Method | Description
Write(ouput: string) | Sends output into output window
WriteLn(output: string) | Sends output into output window and appends end-of-line marker
MsgBox(value: string; caption: string; buttons: int): int | Shows message box with specified text, caption and buttons. Function is analog of MsgBox funtion in VBScript.
ExporeObject(obj: Object) | Shows "COM Object Explorer" dialog and lets you examine/change object properties.
DoEvents() | Processes messages queue.
Sleep(Milliseconds: Integer) | Sleeps specified number of milliseconds.

"WScript" object is added for compatibility with Windows Script Host. This object simulates WScript object from WSH but it is not the same object. For example, connecting events is not supported

Property/Method | Description
Arguments | Always returns null.
Build version | Returns 0.
FullName | Returns path to wwwSharp.exe.
Interactive | Returns True.
Name | Returns "www-Sharp".
Path | Returns path to wwwSharp.exe.
ScriptFullName | Returns empty string.
StdErr | Returns null.
StdIn | Returns null.
StdOut | Returns null.
Version | Returns 1.
ConnectObject(obj: Object; strPrefix: string) | Not supported.
CreateObject(strProgID: string; strPrefix: string) | Creates object with specified ProgID. If strPrefix is specified and is not empty string - error is raied saying that connect object is not implemented.
DisconnectObject(obj: Object) | Not supported.
Echo(str1: string; str2: string ...) | Outputs up to 16 strings (in one Echo call) into output window.
GetObject(strPathName: string) | Returns object from specified path.
Quit(intErrorCode: int) | Returns from the script. Does nothing in JScript.Net.
Sleep(intTime: int) | Stops executing script for specified number of milliseconds.

"Application" object represents www-Sharp application. Look www-Sharp objects for details.

Custom objects - you can add custom objects that will be available from script. Custom object is script file written in any supported script language (JScript, VBScript and any other installed ActiveX script). You can refer this script as object with name you assigned to it in "Select script objects" dialog that can be invoked from toolbar. This script file should have no global code because it can be loaded/unloaded on any time.

For script you can select type libraries ("Select type liraries" button on toolbar). You can then access constants that are defined in this type libraries. Class names defined in type libraries are not available.

With "Edit .Net references" you can select .Net assemblies that will be referenced by JScript.Net script or .Net program.


www-Sharp WMI viewer

WebSharp WMI viewer

Windows Management Instrumentation (WMI) is a component of the Microsoft® Windows® operating system that provides management information and control in an enterprise environment. Using industry-wide standards, WMI allows managers to query and set information on desktop systems, applications, networks, and other enterprise components. Developers can use WMI to create event monitoring applications that alert users when important incidents occur. WMI also offers a variety of programming interfaces, such as C++, ODBC, Microsoft® Visual Basic®, or HTML, that developers can use to further tailor their management applications. Finally, WMI integrates with other Windows components, such as Active Directory™, to allow for a unified management experience.

WebSharp WMI viewer lets you expore WMI classes and properties, examine WQL queries.


www-Sharp ADSI viewer

www-Sharp Active Directories viewer

This viewer is available only on Windows 2000, Windows XP and Windows 2003.

Active Directory™ is the directory service that provides the foundation for distributed networks built on Windows 2000 and later domain controllers. The Active Directory APIs provide access to the data stored in the directory.

Active Directory Service Interfaces (ADSI) is a set of COM interfaces used to access the capabilities of directory services from different network providers in a distributed computing environment, to present a single set of directory service interfaces for managing network resources. Administrators and developers can use ADSI services to enumerate and manage the resources in a directory service, no matter which network environment contains the resource.

ADSI makes it easier to perform common administrative tasks, such as adding new users, managing printers, and locating resources throughout the distributed computing environment.

The Microsoft Exchange Server directory can be accessed using ADSI interfaces. With the ADSI interfaces, you can use high-level tools such as Microsoft Visual Basic®, Java, C, or Microsoft Visual C++® to create directory-enabled applications. With ADSI you need not be concerned about underlying differences between various directory implementations or namespaces because, in the provider-based model that ADSI supports, ADSI can serve as the interface to a number of directory services, accessing each one through its own provider.

This means that you can build applications that use a single point of access to multiple directories in the network environment, whether those directories are based on the Lightweight Directory Access Protocol (LDAP), Novell Directory Services (NDS), or the Microsoft Windows NT® version 4.0 Security Account Manager (NTDS).

www-Sharp Active Directories viewer lets you examine ADSI structure, view ADSI components properties.


www-Sharp database viewer

www-Sharp database viewer lets you examin database structure, explore tables/views/queries contents and execute custom SQL commands.

www-Sharp database viewer uses ADO. Microsoft® ActiveX® Data Objects (ADO) enable your client applications to access and manipulate data from a database server through an OLE DB provider. Its primary benefits are ease of use, high speed, low memory overhead, and a small disk footprint. ADO supports key features for building client/server and web-based applications.

With www-Sharp database viewer you can examin ADO connection and ADO recordset objects and their properties.


www-Sharp COM objects

www-Sharp defines some objects that let use it with scripts and any tools that can work with COM.

wwwSharp.Application

Property/Method | Description
Name | Returns "www-Sharp", read only
Application | Returns application object, read only.
Parent | Returns application object, read only.
Path | Returns the path specification for the application's executable file; read only.
FullName | Returns the file specification for the application, including path; read only.
Left | Sets or returns the distance between the left edge of the physical screen and the main application window; read/write.
Top | Sets or returns the distance between the top edge of the physical screen and main application window; read/write.
Width | Sets or returns the distance between the left and right edges of the main application window; read/write.
Height | Sets or returns the distance between the top and bottom edge of the main application window; read/write.
Caption | Sets or returns the title of the application window; read/write.
StatusBar | Sets or returns the text displayed in the status bar; read/write.
Visible | Sets or returns whether the application is visible to the user; read/write.
Help(file: string; context: int; helpString: string) | Displays online Help.
Quit() | Exits the application and closes all open documents.
CurrentProject | Returns www-Sharp project; read only.
Documents | Returns a collection object for the open documents; read only.
Objects | Scripting.Dictionary that holds user objects. You can store any objects here.
OpenProject(basePath: string; URL: string) | Opens project with specified base path and URL.
OpenNamedProject(name: string) | Open project with specified name.

wwwSharp.Project:

Property/Method | Description
Name | Name of the project; read/write.
Application | Returns application object, read only.
Parent | Returns application object, read only.
Path | Returns base path of the project, read-only.
URL | Returns URL of the project, read-only.
Objects | Scripting.Dictionary that holds user objects. You can store any objects here.

wwwSharp.Documents:

Property/Method | Description
Application | Returns application object, read only.
Parent | Returns the parent of the Documents collection object; read only.
Count | Returns the number of items in the collection; read only.
Item[index] | Returns a Document object from the collection.
Add(docType: string): object | Creates a new document and adds it to the collection. Returns the document that was created.
Open(fileName: string): object | Opens an existing document and adds it to the collection. Returns the document that was opened.
SaveAll() | Saves all documents in collection.
Close() | Closes all documents in the collection.

wwwSharp.Document:

Property/Method | Description
Application | Returns the Application object; read only.
Parent | Returns the Parent property of the Document object; read only.
FullName | Returns the file specification of the document, including the path; read only.
Path | Returns the path specification for the document, not including the file name or file name extension; read only.
Saved | Returns True if the document has never been saved, but has not changed since it was created. Returns True if it has been saved and has not changed since last saved. Returns False if it has never been saved and has changed since it was created; or if it was saved, but has changed since last saved. Read only.
ReadOnly | Returns True if the document is read only, otherwise False; read only.
Name | Returns the file name of the document, not including the file's path specification; read only.
DocType | Returns type of the document.
Title | Sets or returns summary information about the title of the document; read/write.
Text | Returns text property of the document, actual value depends on document type. Read/write.
Objects | Scripting.Dictionary associated with document. Here you can store document-related objects.
Open(fileName: string) | Opens file in this document.
Save() | Saves changes to the file specified in the document's FullName property.
SaveAs(fileName: string) | Saves changes to a file.
RevertToSaved() | Reverts to the last saved copy of the document, and discards any changes.
Close() | Closes all windows associated with the document and removes the document from the Documents collection.
Activate() | Activates the window associated with the document.
Print() | Prints the document.
PrintOut() | Same as Print method, but provides an easier way to use the method in Visual Basic, because Print is a Visual Basic keyword.
PrintPreview() | Previews the pages and page breaks of the document.

Depending on DocType document can expose additional properties/methods.

wwwSharp.SynDocument:

Implemented for Syntax editor. DocType is "SynEdit".

Property/Method | Description
SynDocument | Returns syntax document.

wwwSharp.SyntaxDocument:

Property/Method | Description
Text | Returns/sets document text.
Lines | Returns Lines object.
Highlighter | Returns/sets highlighter name.
Bookmark[index: int] | Returns Bookmark position (line number, one-based). Index is number from 0 to 9.
SelText | Returns/sets selected text.
SelStart | Returns start selection position. Returned object has two properties: Line (default) and Column.
SelEnd | Returns end selection position. Returned object has two properties: Line (default) and Column.
LoadFromFile(fileName: string) | Loads text from file.
SaveToFile(fileName: string) | Saves text into file.
Cut() | Cuts into clipboard.
Copy() | Copies into clipboard.
Paste() | Paste from clipboard.

wwwSharp.TextEditor:

Implemented for RTF editor. DocType is "RTF".

Property/Method | Description
TxtDocument | TextDocument object - the same object that is used in Microsoft® Word and Microsoft® Visual Studio.

wwwSharp.HtmlEditor:

Implemented for HTML editor. DocType is "HTML".

Property/Method | Description
HtmlDocument | Switchs HTML editor into designer view and returns designer's HTML document object.

wwwSharp.XmlEditor:

Implemented for XML editor. DocType is "XML".

Property/Method | Description
XmlDocument | Switchs editor into designer view and returns XML document object.

wwwSharp.DatabaseEditor:

Implemented for database editor. DocType is "Database";

Property/Method | Description
Connection | Returns connection object used by database editor.
Recordset | Returns recordset object used by database editor.

Other editors/viewers do not expose additional properties and methods. DocTypes are:

  • Script console - "ScriptConsole"
  • Type libraries viewer - "TypeLibraries"
  • .Net assemblies viewer - "NetAssemblies"
  • Browser - "Browser"
  • WMI viewer - "WMI"
  • ADS viewer - "ADS"


Special thanks

www-Sharp's author thanks authors of following programs/components that are used in www-Sharp:

Component | Description

Mike Lischke for:

VirtualTreeView

Virtual Treeview is a treeview control built from ground up. More than 3 years of development made it one of the most flexible and advanced tree controls available today. Virtual Treeview starts off with the claim to improve many aspects of exisiting solutions and introduces some new technologies and priniciples which were not available before.

As the name already indicates, this control uses a different paradigm for tree management than other controls of this kind. It does not know anything about the data it manages (except its size), not even the captions of a node. Everything is retrieved from the application via events (or descentants via overridden methods).

Virtual Treeview has been carefully designed and thoroughly tested. The control proved its concept as well as everyday fitness already in many commercial products and freeware projects.

Troy Wolbrink for:

Tnt Delphi Unicode Controls

Designing software for an international audience, I've always wanted to write a full UNICODE application. My approach so far, has been to write Unicode on the inside, and MBCS on the outside. This has always been frustrating, because (even on Windows NT/2000/XP which provide native Unicode window controls) the WideStrings inside my application and databases were always confined to an ANSI VCL. And, since the VCL was designed to wrap the low-level Windows details, why shouldn't the VCL hide the fact that sometimes native Unicode controls are not possible on the given version of Windows. I believe the VCL should be written with a Unicode interface, even if it must (at times) deal with an ANSI operating system. For example, TEdit should expose Text as a WideString, even if it has to convert the WideString to an AnsiString on the Windows 9X platform.
SynEdit team The primary purpose of SynEdit is to be a syntax highlighting editor for
programming languages. There are already more than 30 highlighter components for different languages, and writing a highlighter is not very difficult.
PHP team | PHP is a widely-used general-purpose scripting language that is especially suited for Web development and can be embedded into HTML. If you are new to PHP and want to get some idea of how it works, try the introductory tutorial. After that, check out the online manual, and the example archive sites and some of the other resources available in the links section.

Kambiz R. Khojasteh for:

DelphiArea components

 Some those components are used in www-Sharp.

Krzysztof Kochanski for:

HTML parser

Today we see more and more email messages formatted as HTML. For me the email is plain text medium (with attachments) and I don't use WebBrowser or Mozilla object as a message browser in my email client. So I'm write quick and dirty HTML parser instead. It seems enough to parse email messages but some work is needed to shift them to more general purpose HTML parser.

This parser is used in HtmlHelp designer.
MiniZip team

Delphi component for work with zip archives.


Licences

END USER LICENSE AGREEMENT FOR WWW-SHARP.

IMPORTANT-READ CAREFULLY: This Software End-User License Agreement ("EULA") is a legal agreement between you (either an individual person or a single legal entity, who will be referred to in this EULA as "You") and the mentioned author (Viatcheslav V. Vassiliev, "Author") for the software product that accompanies this EULA, including any associated media, printed materials and electronic documentation (the "Software Product"). The Software Product also includes any software updates, add-on components, web services and/or supplements that Author may provide to You or make available to You after the date You obtain Your initial copy of the Software Product to the extent that such items are not accompanied by a separate license agreement or terms of use. By installing, copying, downloading, accessing or otherwise using the Software Product, You agree to be bound by the terms of this EULA. If You do not agree to the terms of this EULA, do not install, access or use the Software Product; instead, You should return it to Your place of purchase for a full refund.

SOFTWARE PRODUCT LICENSE

The Software Product is protected by intellectual property laws and treaties. The Software Product is licensed, not sold.

1. GRANT OF LICENSE. This Section of the EULA describes Your general rights to install and use the Software Product. The license rights described in this Section are subject to all other terms and conditions of this EULA.
General License Grant to Install and Use Software Product. You may install and use one copy of the Software Product on a single computer, device, workstation, terminal, or other digital electronic or analog device ("Device"). You may make a second copy of the Software Product and install it on a portable Device for the exclusive use of the person who is the primary user of the first copy of the Software Product. A license for the Software Product may not be shared.

Alternative License Grant for Storage/Network Use. As an alternative to the rights granted in the previous section, You may install a copy of the Software Product on one storage Device, such as a network server, and allow individuals within Your business or enterprise to access and use the Software Product from other Devices over a private network, provided that You acquire and dedicate a license for the storage Device upon which the Software Product is installed and each separate Device from which the Software Product is accessed and used. A license for the Software Product may not be used concurrently on different Devices.

Additional License Grant for Media Elements. The Software Product may include certain photographs, clip art, animations, sounds, music and video clips (together "Media Elements"). If so, the following terms describe Your rights to the Media Elements:

(a) Except as specified in the next Section, You may use, copy and modify the Media Elements and distribute copies of the Media Elements, along with Your modifications, as part of Your software product(s) and service(s), including Your web site(s).

(b) You are not licensed to do any of the following:
(i) You may not sell, license or distribute copies of the Media Elements on a stand-alone basis or as part of any collection, product or service where the primary value of the product or service are the Media Elements.
(ii) You may not use or distribute any of the Media Elements that include representations of identifiable individuals, governments, logos, initials, emblems, trademarks, or entities for any commercial purposes or to express or imply any endorsement or association with any product, service, entity, or activity.
(iii) You may not create obscene or scandalous works, as defined by federal law at the time the work is created, using the Media Elements.

(c) You must indemnify, hold harmless, and defend Author from and against any claims or lawsuits, including attorneys' fees, that arise from or result from the use or distribution of Media Elements as modified by You.

(d) You must include a valid copyright notice on Your products and services that include copies of the Media Elements.

(e) You may not permit third parties to distribute copies of the Media Elements except as part of Your product or service.

Reservation of Rights. All rights not expressly granted are reserved by Author.

2. DESCRIPTION OF OTHER RIGHTS AND LIMITATIONS.
Mandatory Activation. You may not be able to exercise Your rights to the Software Product under this EULA after trial period (30 days) expiration unless You register Your copy of the Software Product.

Copy Protection. The Software Product may include copy protection technology to prevent the unauthorized copying of the Software Product or may require original media for use of the Software Product on the Device. It is illegal to make unauthorized copies of the Software Product or to circumvent any copy protection technology included in the Software Product.

Not for Resale Software. If the Software Product is labeled "Not For Resale" or "NFR," then, notwithstanding other sections of this EULA, Your use of the Software Product is limited to use for demonstration, test, or evaluation purposes and You may not resell, or otherwise transfer for value, the Software Product.

Limitations on Reverse Engineering, Decompilation, and Disassembly. You may not reverse engineer, decompile, or disassemble the Software Product, except and only to the extent that such activity is expressly permitted by applicable law notwithstanding this limitation.

Separation of Component Parts. The Software Product is licensed as a single product. Its component parts may not be separated for use on more than one Device unless expressly permitted by this EULA.

Trademarks. This EULA does not grant You any rights in connection with any trademarks or service marks of Author.

No rental, leasing or commercial hosting. You may not rent, lease, lend or provide commercial hosting services to third parties with the Software Product.

Support Services. Author may provide You with support services related to the Software Product ("Support Services"). Use of Support Services is governed by the Author policies and programs described in the user manual, in "online" documentation, or in other Author-provided materials. Any supplemental software code provided to You as part of the Support Services are considered part of the Software Product and subject to the terms and conditions of this EULA. You acknowledge and agree that Author may use technical information You provide to Author as part of the Support Services for its business purposes, including for product support and development. Author will not utilize such technical information in a form that personally identifies You.

Software Transfer. Except as specified in this Section, the initial licensee of the Software Product may make a one-time permanent transfer of this EULA and Software Product only directly to an end user. This transfer must include all of the Software Product (including all component parts, the media and printed materials, any upgrades, this EULA, and, if applicable, the Certificate of Authenticity). Such transfer may not be by way of consignment or any other indirect transfer. The transferee of such one-time transfer must agree to comply with the terms of this EULA, including the obligation not to further transfer this EULA and Software Product.

Termination. Without prejudice to any other rights, Author may terminate this EULA if You fail to comply with the terms and conditions of this EULA. In such event, You must destroy all copies of the Software Product and all of its component parts.

3. UPGRADES. Standard Software Product. If the Software Product is labeled as an upgrade, You must be properly licensed to use a product identified by Author as being eligible for the upgrade in order to use the Software Product. A Software Product labeled as an upgrade replaces or supplements (and may disable) the product that formed the basis for Your eligibility for the upgrade. You may use the resulting upgraded product only in accordance with the terms of this EULA. If the Software Product is an upgrade of a component of a package of software programs that You licensed as a single product, the Software Product may be used and transferred only as part of that single product package and may not be separated for use on more than one Device.

4. INTELLECTUAL PROPERTY RIGHTS. All title and intellectual property rights in and to the Software Product (including but not limited to any images, photographs, animations, video, audio, music, text, and "applets" incorporated into the Software Product), the accompanying printed materials, and any copies of the Software Product are owned by Author or its suppliers. All title and intellectual property rights in and to the content that is not contained in the Software Product, but may be accessed through use of the Software Product, is the property of the respective content owners and may be protected by applicable copyright or other intellectual property laws and treaties. This EULA grants You no rights to use such content. If this Software Product contains documentation that is provided only in electronic form, you may print one copy of such electronic documentation. You may not copy the printed materials accompanying the Software Product.

5. BACKUP COPY. After installation of one copy of the Software Product pursuant to this EULA, you may keep the original media on which the Software Product was provided by Author solely for backup or archival purposes. If the original media is required to use the Software Product on the Device, you may make one copy of the Software Product solely for backup or archival purposes. Except as expressly provided in this EULA, you may not otherwise make copies of the Software Product or the printed materials accompanying the Software Product.

6. LIMITED WARRANTY
LIMITED WARRANTY FOR SOFTWARE PRODUCTS. Author warrants that the SOFTWARE PRODUCT will perform substantially in accordance with the accompanying materials for a period of ninety (90) days from the date of receipt.

Any supplements or updates to the SOFTWARE PRODUCT, including without limitation, any (if any) service packs or hot fixes provided to you after the expiration of the ninety (90) day Limited Warranty period are not covered by any warranty or condition, express, implied or statutory.

LIMITATION ON REMEDIES; NO CONSEQUENTIAL OR OTHER DAMAGES. Your exclusive remedy for any breach of this Limited Warranty is as set forth below. Except for any refund elected by Author, YOU ARE NOT ENTITLED TO ANY DAMAGES, INCLUDING BUT NOT LIMITED TO CONSEQUENTIAL DAMAGES, if the Software Product does not meet Author's Limited Warranty, and, to the maximum extent allowed by applicable law, even if any remedy fails of its essential purpose. The terms of Section 8 below ("Exclusion of Incidental, Consequential and Certain Other Damages") are also incorporated into this Limited Warranty.

7. DISCLAIMER OF WARRANTIES. THE LIMITED WARRANTY THAT APPEARS ABOVE IS THE ONLY EXPRESS WARRANTY MADE TO YOU AND IS PROVIDED IN LIEU OF ANY OTHER EXPRESS WARRANTIES (IF ANY) CREATED BY ANY DOCUMENTATION OR PACKAGING. EXCEPT FOR THE LIMITED WARRANTY AND TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, AUTHOR AND ITS SUPPLIERS PROVIDE THE SOFTWARE AND SUPPORT SERVICES (IF ANY) AS IS AND WITH ALL FAULTS, AND HEREBY DISCLAIM ALL OTHER WARRANTIES AND CONDITIONS, EITHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, ANY (IF ANY) IMPLIED WARRANTIES, DUTIES OR CONDITIONS OF MERCHANTABILITY, OF FITNESS FOR A PARTICULAR PURPOSE, OF ACCURACY OR COMPLETENESS OR RESPONSES, OF RESULTS, OF WORKMANLIKE EFFORT, OF LACK OF VIRUSES AND OF LACK OF NEGLIGENCE, ALL WITH REGARD TO THE SOFTWARE, AND THE PROVISION OF OR FAILURE TO PROVIDE SUPPORT SERVICES. ALSO, THERE IS NO WARRANTY OR CONDITION OF TITLE, QUIET ENJOYMENT, QUIET POSSESSION, CORRESPONDENCE TO DESCRIPTION OR NON-INFRINGEMENT WITH REGARD TO THE SOFTWARE.

8. EXCLUSION OF INCIDENTAL, CONSEQUENTIAL AND CERTAIN OTHER DAMAGES. TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, IN NO EVENT SHALL AUTHOR OR ITS SUPPLIERS BE LIABLE FOR ANY SPECIAL, INCIDENTAL, INDIRECT, OR CONSEQUENTIAL DAMAGES WHATSOEVER (INCLUDING, BUT NOT LIMITED TO, DAMAGES FOR LOSS OF PROFITS OR CONFIDENTIAL OR OTHER INFORMATION, FOR BUSINESS INTERRUPTION, FOR PERSONAL INJURY, FOR LOSS OF PRIVACY, FOR FAILURE TO MEET ANY DUTY INCLUDING OF GOOD FAITH OR OF REASONABLE CARE, FOR NEGLIGENCE, AND FOR ANY OTHER PECUNIARY OR OTHER LOSS WHATSOEVER) ARISING OUT OF OR IN ANY WAY RELATED TO THE USE OF OR INABILITY TO USE THE SOFTWARE PRODUCT, THE PROVISION OF OR FAILURE TO PROVIDE SUPPORT SERVICES, OR OTHERWISE UNDER OR IN CONNECTION WITH ANY PROVISION OF THIS EULA, EVEN IN THE EVENT OF THE FAULT, TORT (INCLUDING NEGLIGENCE), STRICT LIABILITY, BREACH OF CONTRACT OR BREACH OF WARRANTY OF AUTHOR OR ANY SUPPLIER, AND EVEN IF AUTHOR OR ANY SUPPLIER HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

9. LIMITATION OF LIABILITY AND REMEDIES. NOTWITHSTANDING ANY DAMAGES THAT YOU MIGHT INCUR FOR ANY REASON WHATSOEVER (INCLUDING, WITHOUT LIMITATION, ALL DAMAGES REFERENCED ABOVE AND ALL DIRECT OR GENERAL DAMAGES), THE ENTIRE LIABILITY OF AUTHOR AND ANY OF ITS SUPPLIERS UNDER ANY PROVISION OF THIS EULA AND YOUR EXCLUSIVE REMEDY FOR ALL OF THE FOREGOING (EXCEPT FOR ANY REMEDY OF REPAIR OR REPLACEMENT ELECTED BY AUTHOR WITH RESPECT TO ANY BREACH OF THE LIMITED WARRANTY) SHAL BE LIMITED TO THE GREATER OF THE AMOUNT ACTUALLY PAID BY YOU FOR THE SOFTWARE OR U.S. $0.02. THE FOREGOING LIMITATIONS, EXCLUSIONS AND DISCLAIMERS (INCLUDING SECTIONS 6, 7, AND 8 ABOVE) SHALL APPLY TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, EVEN IF ANY REMEDY FAILS ITS ESSENTIAL PURPOSE.

10. ENTIRE AGREEMENT. This EULA (including any addendum or amendment to this EULA which is included with the Software Product) is the entire agreement between you and Author relating to the Software Product and the support services (if any) and they supersede all prior or contemporaneous oral or written communications, proposals and representations with respect to the Software Product or any other subject matter covered by this EULA. To the extent the terms of any Author policies or programs for support services conflict with the terms of this EULA, the terms of this EULA shall control.